<?php
/*
  $Id: shop_by_price.php
  $Loc: catalog/

  2020 Shop by Price 5.3.2 CE Phoenix
  by @raiwa
  raiwa@phoenixcartaddons.com
  www.phoenixcartaddons.com

  Copyright (c) 2020 Rainer Schmied

  Based on:
  Contribution by Meltus  http://www.highbarn-consulting.com
  Adapted for OsCommerce MS2 by Sylvio Ruiz suporte@leilodata.com
  Modified by Hugues Deriau on 09/23/2006 - display the price ranges in the selected currency
  Modified by Glassraven for dropdown list 24/10/2006 www.glassraven.com
  Modified by -GuiGui- (http://www.gpuzin.com) - 07/03/2008 - fix the title and work with the contribution " Product Listing in Columns"

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  require 'includes/application_top.php';

  require "includes/languages/$language/shop_by_price.php";

  $price_min = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  array_unshift($price_min, 0);
  $price_max = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  array_push($price_max, 0);

  // Initialize the varaible '$range' from param here because it's used in shop_by_price.php
  $range = null;
  if ( isset($_GET['range']) ) {
    $range = $_GET['range']-1;
  } elseif ( isset($_GET['lrange']) ) {
    $range = $_GET['lrange'];
  }

  $currencies_rate_query = $db->query("SELECT value FROM currencies WHERE code = '" . $currency . "'");
  $currency_rate = $currencies_rate_query->fetch_assoc();

  $pfrom = isset($price_min[$range]) ? $price_min[$range]/$currency_rate['value']  : 0;
  $pto   = isset($price_max[$range]) ? $price_max[$range]/$currency_rate['value']  : 0;

  $select_str = sprintf("SELECT DISTINCT m.*, %s", Product::COLUMNS);

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (!Text::is_empty($pfrom) || !Text::is_empty($pto)) ) {
    $select_str .= ", SUM(tr.tax_rate) AS tax_rate";
  }

  $from_str = <<<'EOSQL'
 FROM products p
  INNER JOIN products_description pd ON p.products_id = pd.products_id
  INNER JOIN products_to_categories p2c ON p.products_id = p2c.products_id
  INNER JOIN categories c ON p2c.categories_id = c.categories_id
  LEFT JOIN manufacturers m USING(manufacturers_id)
  LEFT JOIN specials s ON p.products_id = s.products_id
  LEFT JOIN (SELECT products_id, COUNT(*) AS attribute_count FROM products_attributes GROUP BY products_id) a ON p.products_id = a.products_id
EOSQL;

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (!Text::is_empty($pfrom) || !Text::is_empty($pto)) ) {
    if (isset($customer) && ($customer instanceof customer)) {
      $country_id = $customer->get('country_id');
      $zone_id = $customer->get('zone_id');
    } else {
      $country_id = STORE_COUNTRY;
      $zone_id = STORE_ZONE;
    }
    if ( (defined('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_FAST_TAX_QUERY') && MODULE_CONTENT_HEADER_SHOP_BY_PRICE_USE_FAST_TAX_QUERY == 'True') || (defined('MODULE_BOXES_SHOP_BY_PRICE_USE_FAST_TAX_QUERY') && MODULE_BOXES_SHOP_BY_PRICE_USE_FAST_TAX_QUERY == 'True') ) {
      $from_str .= " LEFT JOIN tax_rates tr ON p.products_tax_class_id = tr.tax_class_id INNER JOIN zones_to_geo_zones gz ON tr.tax_zone_id = gz.geo_zone_id AND (gz.zone_country_id IS NULL OR gz.zone_country_id = '0' OR gz.zone_country_id = " . (int)$country_id . ") AND (gz.zone_id IS NULL OR gz.zone_id = '0' OR gz.zone_id = " . (int)$zone_id . ")";
    } else {
      $from_str .= " LEFT JOIN tax_rates tr ON p.products_tax_class_id = tr.tax_class_id LEFT JOIN zones_to_geo_zones gz ON tr.tax_zone_id = gz.geo_zone_id AND (gz.zone_country_id IS NULL OR gz.zone_country_id = '0' OR gz.zone_country_id = " . (int)$country_id . ") AND (gz.zone_id IS NULL OR gz.zone_id = '0' OR gz.zone_id = " . (int)$zone_id . ")";
    }
  }

  $where_str = " WHERE p.products_status = 1 AND pd.language_id = " . (int)$_SESSION['languages_id'];

  if (isset($_GET['categories_id']) && !Text::is_empty($_GET['categories_id'])) {
    if (isset($_GET['inc_subcat']) && ($_GET['inc_subcat'] == '1')) {
      $where_str .= " AND p2c.products_id = p.products_id AND p2c.products_id = pd.products_id AND (p2c.categories_id = " . (int)$_GET['categories_id'];

      foreach (Guarantor::ensure_global('category_tree')->get_descendants($_GET['categories_id']) as $subcategory_id) {
        $where_str .= " OR p2c.categories_id = " . (int)$subcategory_id;
      }

      $where_str .= ")";
    } else {
      $where_str .= " AND p2c.products_id = p.products_id AND p2c.products_id = pd.products_id AND pd.language_id = " . (int)$_SESSION['languages_id'] . " AND p2c.categories_id = " . (int)$_GET['categories_id'];
    }
  }

  if (isset($_GET['manufacturers_id']) && !Text::is_empty($_GET['manufacturers_id'])) {
    $where_str .= " AND m.manufacturers_id = " . (int)$_GET['manufacturers_id'];
  }

  if (DISPLAY_PRICE_WITH_TAX == 'true') {
    if ($pfrom > 0) $where_str .= " AND (IF(s.status, s.specials_new_products_price, p.products_price) * IF(gz.geo_zone_id IS NULL, 1, 1 + (tr.tax_rate / 100) ) >= " . (double)$pfrom . ")";
    if ($pto > 0) $where_str .= " AND (IF(s.status, s.specials_new_products_price, p.products_price) * IF(gz.geo_zone_id IS NULL, 1, 1 + (tr.tax_rate / 100) ) <= " . (double)$pto . ")";
  } else {
    if ($pfrom > 0) $where_str .= " AND (IF(s.status, s.specials_new_products_price, p.products_price) >= " . (double)$pfrom . ")";
    if ($pto > 0) $where_str .= " AND (IF(s.status, s.specials_new_products_price, p.products_price) <= " . (double)$pto . ")";
  }

  if ( (DISPLAY_PRICE_WITH_TAX == 'true') && (!Text::is_empty($pfrom) || !Text::is_empty($pto)) ) {
    $where_str .= " GROUP BY p.products_id, tr.tax_priority";
  }

  $listing_sql = $select_str . $from_str . $where_str;

  if (class_exists('cm_header_shop_by_price')) {
    $shop_by_price_format = new cm_header_shop_by_price();
  } else if (class_exists('bm_shop_by_price')) {
    $shop_by_price_format = new bm_shop_by_price();
  }

  $price_ranges = [];
  $price_ranges_array = explode(',', defined('MODULE_BOXES_SHOP_BY_PRICE_STATUS')? constant('MODULE_BOXES_SHOP_BY_PRICE_PRICE_RANGE_' . $currency) : constant('MODULE_CONTENT_HEADER_SHOP_BY_PRICE_PRICE_RANGE_' . $currency));
  $price_ranges[0] =  TEXT_SHOP_BY_PRICE_LESS_THAN .  $shop_by_price_format->format0($price_ranges_array[0]);
  for ($price_range=1; $price_range<sizeof($price_ranges_array); $price_range++) {
    $price_ranges[$price_range] = $shop_by_price_format->format0($price_ranges_array[$price_range-1]) . " &minus; " . $shop_by_price_format->format0($price_ranges_array[$price_range]);
  }
  $price_ranges[sizeof($price_ranges_array)] =  TEXT_SHOP_BY_PRICE_MORE_THAN .  $shop_by_price_format->format0($price_ranges_array[sizeof($price_ranges_array)-1]);
  $price_ranges[sizeof($price_ranges_array)+1] =  TEXT_SHOP_BY_PRICE_ALL;

  if (($brand ?? null) instanceof manufacturer) {
    $manufacturer_name  = $brand->getData('manufacturers_name');
  } elseif ( isset($_GET['cPath']) ) {
    $category_name  = $category_tree->get($current_category_id, 'name');
  }


  require $Template->map(__FILE__, 'page');

  require 'includes/application_bottom.php';
