<?php
/*
  $Id: shop_by_price.php
  $Loc: catalog/templates/default/includes/pages/

  2020 Shop by Price 5.3.0 CE Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Based on:
  Contribution by Meltus  http://www.highbarn-consulting.com
  Adapted for OsCommerce MS2 by Sylvio Ruiz suporte@leilodata.com
  Modified by Hugues Deriau on 09/23/2006 - display the price ranges in the selected currency
  Modified by Glassraven for dropdown list 24/10/2006 www.glassraven.com
  Modified by -GuiGui- (http://www.gpuzin.com) - 07/03/2008 - fix the title and work with the contribution " Product Listing in Columns"

  Copyright (c) 2020 Rainer Schmied
  Copyright (c) 2020 osCommerce
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  $breadcrumb->add(NAVBAR_TITLE, $Linker->build('shop_by_price.php')->retain_query_except());

  require $Template->map('template_top.php', 'component');
  
  if (!isset($range)) {
    $heading_title = HEADING_TITLE_1;
  } else {
    $heading_title = HEADING_TITLE_PRODUCTS;
    if (isset($_GET['cPath'])) {
      $heading_title .= HEADING_TITLE_CATEGORY . $category_name . '<br>';
    } elseif (isset($_GET['manufacturers_id'])) {
      $heading_title .= HEADING_TITLE_MANUFACTURER . $manufacturer_name  . '<br>';
    }
    if ($range >= 0) {
      if ($range == sizeof($price_ranges_array)+1) {
        $heading_title .= HEADING_TITLE_WITH;
      } else {
        $heading_title .= HEADING_TITLE_PRICE;
      }
      $heading_title .= $price_ranges[$range];
    }
  }
?>

<h1 class="display-4"><?=  $heading_title ?></h1>

<?php
  require 'includes/system/segments/sortable_product_listing.php';
?>

  <br>

  <div class="buttonSet">
    <?= new Button(IMAGE_BUTTON_BACK, 'fas fa-angle-left', null, [], $Linker->build('index.php')->retain_query_except(['page', 'range'])) ?>
  </div>

<?php
  require $Template->map('template_bottom.php', 'component');
?>
